.TH "﻿TXT2TAGS" 1 "Aug, 2010" ""


.SH NAME

.P
txt2tags \- Textformatierungs\- und \-konvertierungswerkzeug

.SH SYNOPSIS

.P
\fBtxt2tags\fR [\fIOptionen\fR] [\fIDATEI\fR...]

.SH BESCHREIBUNG

.P
\fBtxt2tags\fR liest einen Text mit minimalem Markup und konvertiert ihn zu:
\fIASCII Art\fR,
\fIAsciiDoc\fR,
\fICreole\fR,
\fIDocBook\fR,
\fIDokuWiki\fR,
\fIGoogle Code Wiki\fR,
\fIHTML\fR,
\fILaTeX\fR,
\fILout\fR,
\fIMagicPoint\fR,
\fIMan page\fR,
\fIMoinMoin\fR,
\fIPageMaker\fR,
\fIPlain Text\fR,
\fIPmWiki\fR,
\fISGML\fR,
\fIWikipedia\fR und
\fIXHTML\fR.

.P
\fBtxt2tags\fR liest eine Textdatei mit minimalem Markup und wandelt ihn um in:
ASCII\-Art, AsciiDoc, Creole, DocBook, DokuWiki, Google Code Wiki,
HTML, LaTeX, Lout, MagicPoint, Manpage, MoinMoin, PageMaker,
Plain Text, PmWiki, SGML, Wikipedia und XHTML.

.P
Diese Manpage wurde von txt2tags aus einer einfachen Textdatei erstellt.
Der gleiche Textdatei wird auch für die Online\-Version dieses Handbuchs in HTML umgewandelt.
Eine Quelle, MULTI\-Ziele \- http://txt2tags.org

.P
EIN Quellformat, VIELE Zielformate \- http://txt2tags.org

.SH MARKUP

.nf
Headers           Die ersten 3 Zeilen der Quelldatei
Titel             = Wörter =
Nummerierter Titel + Wörter +
Kommentar         % Kommentare
Trennungslinie    -----------------------...
Dicke Linie       =======================...
Bild              [Dateiname.jpg]
Link              [Marke url]

Fett              **Wörter**
Italic            //Wörter//
Understrichen     __Wörter__
Durchgestrichen   --Wörter--
Monospaced        ``Wörter``
Raw               ""Wörter""
Tagged            ''Wörter''

Absatz            Wörter
Zitat             <TAB>Wörter
Liste             - Wörter
Numerierte Liste  + Wörter
Definitionsliste  : Wörter
Tabelle           | Zelle 1 | Zelle 2 | Zelle 3 ...

Verbatim-Zeile    ``` Wörter
Raw-Zeile         """ Wörter
Tagged-Zeile      ''' Wörter

Verbatim-Block    ```
                  Zeilen
                  ```
Raw-Block         """
                  Zeilen
                  """
Tagged-Block      '''
                  Zeilen
                  '''
.fi


.SH OPTIONEN

.TP
    \fB\-\-art\-chars\fR=\fIMUSTER\fR
Definiert \fIMUSTER\fR als das Muster von Zeichen, die ASCII\-Kunst darstellen, in der folgenden Reihenfolge: corner, border, side, bar1, bar2, level2, level3, level4, level5. Der Standardwert für das Zeichenmuster ist +\-|\-==\-^". Diese Option wird nur bei ASCII\-Kunst als Zielformat benutzt.

.TP
\fB\-C\fR, \fB\-\-config\-file\fR=\fIDATEI\fR
Liest die Konfiguration aus einer externen \fIDATEI\fR. Die Konfiguration muß im Format \fI%!keyword:value\fR stehen. Siehe die Erläuterungen im Abschnitt EINSTELLUNGEN .

.TP
    \fB\-\-css\-sugar\fR
Verbessert den erzeugten HTML/XHTML\-Code, wenn CSS\-Dateien verwendet werden. Tag\-Attribute werden entfernt, Darstellungs\-Tags werden vermieden, Überschriften bestehen aus H1, H2 und H3 Tags, neue DIVs werden erzeugt: \fI#header\fR, \fI#body\fR, \fI.toc\fR.

.TP
    \fB\-\-css\-inside\fR
Fügt den Inhalt einer CSS\-Datei innerhalb der HTML/XHTML\-Kopfzeilen ein. Verwende`\-\-style``, um eine CSS\-Datei anzugeben, die gelesen werden soll.

.TP
    \fB\-\-dump\-config\fR
Druckt die gefundene Konfiguration und beendet.

.TP
    \fB\-\-dump\-source\fR
Druckt das Quelldokument erweitert um die Einfügungen (%!include).

.TP
    \fB\-\-encoding\fR=\fICODE\fR
Informiert über den Zeichensatz (die Dateicodierung), der vom Quelldokument verwendet wird. Beispiele sind UTF\-8 und iso\-8859\-1. Die Codierung wird nicht während der Konvertierung geändert, so dass das Ausgabedokument die gleiche Codierung wie die Quellen erhält.

.TP
    \fB\-\-gui\fR
Ruft die grafische Tk\-Benutzerschnittstelle auf.

.TP
\fB\-h\fR, \fB\-\-help\fR
Druckt den Hilfetext und beendet.

.TP
\fB\-H\fR, \fB\-\-no\-headers\fR
Unterdrückt Kopf\- und Fußzeilen in der Ausgabe. Nur der Inhalt (Body) wird gezeigt.

.TP
    \fB\-\-headers\fR
Zeigt Kopf\- und Fußzeilen in der Ausgabe. Standard ist AN.

.TP
    \fB\-\-height\fR=\fINUM\fR
Setzt die Höhe der Ausgabe zu \fINUM\fR Zeilen. Diese Option wird nur benutzt bei ASCII\-Kunst als Zielformat, wenn auch \-\-slides verwendet wird.

.TP
\fB\-i\fR, \fB\-\-infile\fR=\fIDATEI\fR
Setzt \fIDATEI\fR als Eingabedateiname, das Quelldokument. Verwende '\-', um die Quellen von STDIN zu lesen.

.TP
    \fB\-\-mask\-email\fR
Versteckt E\-Mails vor Spamrobotern. Entfernt @ und Punkte. Die Adresse foo@bar.com wird zu <foo (a) bar com>.

.TP
\fB\-n\fR, \fB\-\-enum\-title\fR
Verwendet die automatische Nummerierung für Titelzeilen. Ihnen wird 1, 1.1, 1.1.1, ... vorangestellt.

.TP
    \fB\-\-no\-dump\-config\fR
Beendet die \-\-dump\-config Aktion.

.TP
    \fB\-\-no\-dump\-source\fR
Beendet die \-\-dump\-source Aktion.

.TP
    \fB\-\-no\-encoding\fR
Löscht die Codierungseinstellung.

.TP
    \fB\-\-no\-enum\-title\fR
Unterdrückt die automatische Nummerierung für Titelzeilen.

.TP
    \fB\-\-no\-infile\fR
Löscht alle vorigen infile\-Deklarationen.

.TP
    \fB\-\-no\-targets\fR
Beendet die \-\-targets Aktion.

.TP
    \fB\-\-no\-mask\-email\fR
Unterdrückt die E\-Mailmaskierung.

.TP
    \fB\-\-no\-outfile\fR
Löscht die vorige outfile\-Deklaration.

.TP
    \fB\-\-no\-quiet\fR
Zeigt Meldungen, unterdrückt die \-\-quiet Option.

.TP
    \fB\-\-no\-rc\fR
Liest nicht die Benutzerkonfigurationsdatei ~/.txt2tagsrc.

.TP
    \fB\-\-no\-slides\fR
Schaltet das slides\-Feature aus.

.TP
    \fB\-\-no\-style\fR
Löscht alle Stileinstellungen.

.TP
    \fB\-\-no\-toc\fR
Entfernt das Inhaltsverzeichnis von der Ausgabe.

.TP
    \fB\-\-no\-toc\-only\fR
Schaltet die \-\-toc\-only Aktion aus.

.TP
\fB\-o\fR, \fB\-\-outfile\fR=\fIDATEI\fR
Setzt \fIDATEI\fR als Ausgabedateiname. Benutzt '\-', um Ergebnisse nach STDOUT zu schicken.

.TP
\fB\-q\fR, \fB\-\-quiet\fR
Stiller Modus. Unterdrückt alle Ausgaben, außer Fehler.

.TP
    \fB\-\-rc\fR
Liest die Benutzerkonfigurationsdatei ~/.txt2tagsrc. Standard ist AN.

.TP
    \fB\-\-slides\fR
Formatiert die Ausgabe als Präsentation. Diese Option wird nur benutzt bei ASCII\-Kunst als Zielformat.

.TP
    \fB\-\-style\fR=\fIDATEI\fR
Verwendet \fIDATEI\fR als Stildatei des Dokuments. Wird benutzt, um CSS\-Dateien für HTML/XHTML\-Dokumente zu definieren und Pakete für LaTeX. Diese Option kann mehrmals verwendet werden, um mehrere Dateien einzufügen.

.TP
\fB\-t\fR, \fB\-\-target\fR=\fITYPE\fR
Setzt das Format des Ausgabedokuments zu \fITYPE\fR. Einige populäre Typen sind: \fIhtml\fR, \fIxhtml\fR, \fItex\fR, \fIman\fR, \fItxt\fR. Benutze die \-\-targets Option, um alle verfügbaren Formate zu sehen.

.TP
    \fB\-\-targets\fR
Druckt eine Liste aller verfügbaren Zielformate und beendet.

.TP
    \fB\-\-toc\fR
Fügt automatisch ein Inhaltsverzeichnis (TOC) in die Ausgabe zwischen Header und Body ein. Die  Position kann mit dem %%TOC Makro festgelegt werden.

.TP
    \fB\-\-toc\-level\fR=\fINUM\fR
Setzt die maximale TOC\-Tiefe zu \fINUM\fR. Alle Titel tiefer als \fINUM\fR werden nicht ins Inhaltsverzeichnis eingefügt.

.TP
    \fB\-\-toc\-only\fR
Druckt nur das Inhaltsverzeichnis und beendet.

.TP
\fB\-v\fR, \fB\-\-verbose\fR
Druckt informative Nachrichten während der Konvertierung. Diese Option kann mehrmals benutzt werden, um die Anzahl der angezeigten Nachrichten zu erhöhen.

.TP
\fB\-V\fR, \fB\-\-version\fR
Druckt die Programmversion und beendet.

.TP
    \fB\-\-width\fR=\fINUM\fR
Setzt die Ausgabebreite auf \fINUM\fR Spalten. Diese Option wird nur bei ASCII\-Kunst als Zielformat verwendet.

.SH QUELLDATEIEN

.P
Die Quelldateien werden normalerweise durch die \fI.t2t\fR Erweiterung (wie in myfile.t2t) ausgewiesen. In den Quelldateien können drei Bereiche vorkommen :

.TP
\fBHeader\fR (optional)
Die ersten drei Zeilen der Datei. Lasse die erste Zeile leer, wenn keine Kopfzeilen gebraucht werden. Wird verwendet für Dokumenttitel, Autor, Version und Datumsinformation.

.TP
\fBSettings\fR (optional)
Beginnt gleich nach dem Header (vierte oder zweite Zeile) und endet, wo der Body beginnt.
Wird benutzt für Einstellungen im %!keyword:value Format.

.TP
\fBBody\fR
Beginnt an der ersten gültigen Textzeile (nicht Kommentar oder Einstellung) nach dem Headerbereich und geht bis zum Ende des Dokuments. Wird für den Dokumentinhalt benutzt.

.SH EINSTELLUNGEN

.P
Mit den Einstellungen kann \fBtxt2tags\fR angepasst werden, ähnlich den Otionen. Sie können im Quelldokument im Bereich Einstellungen benutzt werden, ~/.txt2tagsrc file, die externe Datei wird mit \-\-config\-file aufgerufen.

.TP
\fB%!target\fR
Setzt das Ausgabeformat, wie bei \-\-target. Beispiel:
.nf
%!target: html
.fi



.TP
\fB%!options(target)\fR
Setzt die Standardoptionen für jedes Ziel. Du mußt die Optionen Kommandozeilen benutzen. Beispiel:
.nf
%!options(html): --toc --toc-level 3 --css-sugar
.fi



.TP
\fB%!includeconf\fR
Füge die Konfigurationen aus einer externen Datei in die aktuelle ein, wie bei \-\-config\-file. Beispiel:
.nf
%!includeconf: myconfig.t2t
.fi



.TP
\fB%!style\fR
Setzt eine Stildatei für das document, wie bei \-\-style. Kann mehrmals benutzt werden.  Beispiel:
.nf
%!style: colors.css
.fi



.TP
\fB%!encoding\fR
Setzt den Zeichensatz, der vom Dokument verwendet wird, wie bei \-\-encoding. Beispiel:
.nf
%!encoding: UTF-8
.fi



.TP
\fB%!preproc\fR
Wendet ein Suchen/Ersetzen Filter an, das verwendet wird um den Body vom Quelldokument zu ändern, VOR jedem Parsen durch txt2tags. Die Suche verwendet reguläre Ausdrücke von Python. Beispiel:
.nf
%!preproc:  "JJS"  "John J. Smith"
.fi



.TP
\fB%!postproc\fR
Wendet ein Suchen/Ersetzen Filter an, das verwendet wird um das erzeugte Dokument zu ändern, NACH allem Verarbeiten durch txt2tags. Die Suche verwendet reguläre Ausdrücke von Python. Beispiel:
.nf
%!postproc(html):  "<B>"  "<STRONG>"
.fi



.P
Wenn das gleiche Schlüsselwort mehr als einmal vorkommt, wird das letzte gefundene benutzt (außer bei: Optionen, preproc und postproc, welche kumulativ arbeiten). Ungültige Schlüsselwörter werden ignoriert. Die Reihenfolge ist: ~/.txt2tagsrc, Konfigurationsbereich des Quelldokuments, \-\-config\-file Option.

.SH COMMANDS

.P
Kommandos führen Aufgaben während der Konvertierung aus. Sie müssen in den Body des Quelldokuments geschrieben werden.

.TP
\fB%!csv: Datei.csv\fR
Fügt eine externe CSV\-Datei als Tabelle ein.

.TP
\fB%!include: Datei.t2t\fR
Fügt eine txt2tags\-Datei ein.

.TP
\fB%!include: ``Datei.txt``\fR
Fügt eine Textdatei (verbatim) in das Dokument ein.

.TP
\fB%!include: \&''Datei.html''\fR
Fügt eine bereits getaggte Datei in das Dokument ein.

.SH MAKROS

.P
Makros sind handliche Abkürzungen und erlauben es dynamisch Inhalt ins Dokument einzufügen. Sie müssen in den Body des Quelldokuments gestellt werden. Mit Ausnahme von %%toc können alle Makros mit speziellen Direktiven, wie %Y and %f angepaßt werden. Für Details siehe das txt2tags Benutzerhandbuch.

.TP
\fB%%date\fR
Fügt das aktuelle Datum ein. Das Standardformat ist %%date(%Y%m%d), was YYYYMMDD ergibt.

.TP
\fB%%infile\fR
Fügt den Pfad der Quelldatei ein. Das Standardformat ist %%infile(%f). Nützlich für links in Fußzeilen wie [See source %%infile].

.TP
\fB%%mtime\fR
Füge die Änderungszeit der Quelldatei ein. Das Standardformat ist %%date(%Y%m%d), welche YYYYMMDD ergibt.

.TP
\fB%%outfile\fR
Fügt den Pfad der Ausgabedatei ein. Das Standardformat ist %%outfile(%f). Nützlich für self mentioning wie "Dieses ist die manpage\-de.man Datei".

.TP
\fB%%toc\fR
Bestimmt wo das Inhaltsverzeichnis gesetzt wird. Kann ebenso mehrmals benutzt werden. Dafür muß ebenfalls die \-\-toc Option benutzt werden.

.SH BEISPIELE

.TP
txt2tags \-t html Datei.t2t

Konvertiert nach HTML, speichert in file.html.

.TP
txt2tags \-t html \-o \- Datei.t2t

Konvertiert nach HTML, sendet Ergebnisse nach STDOUT.

.TP
txt2tags \-t html \-\-toc Datei.t2t

Konvertiert nach HTML, fügt automatisch ein Inhaltsverzeichnis ein.

.TP
txt2tags \-t html \-\-toc \-\-toc\-level 2 \-n Datei.t2t

Konvertiert nach HTML, mit einem Inhaltsverzeichnis mit zwei Ebenen und nummerierten Titeln.

.TP
txt2tags \-\-toc\-only Datei.t2t

Zeigt nur das Inhaltsverzeichnis, ohne Konvertierung.

.TP
txt2tags \-t html \-\-css\-sugar \-\-style base.css \-\-style ui.css Datei.t2t

Konvertiert nach HTML, bereitet den sich ergebenden Code vor für CSS, und fügt Aufrufe von zwei externen CSS Dateien ein.

.TP
txt2tags \-t art \-\-slides \-\-width 80 \-\-height 25 \-o \- Datei.t2t | more

Erzeugt Präsentationsfolien in ASCII\-Kunst, um auf einem 80x25 Bildschirm gezeigt zu werden.

.TP
(echo ; echo "**bold**") | txt2tags \-t html \-H \-

Handlicher Einzeiler für schnelle Tests mit STDIN.

.TP
txt2tags \-t html \-o \- Datei.t2t | tidy > Datei.html

Sendet Ergebnisse an STDOUT, dann verfeinere den Code mit einem externen Programm vor dem Speichern der Ausgabedatei.

.SH DATEIEN

.TP
~/.txt2tagsrc
Konfigurationsdatei vom Standardbenutzer.

.SH UMGEBUNG

.TP
T2TCONFIG
Wenn nicht Null, wird der volle Pfadnamen für die Standardkonfigurationsdatei gesetzt.

.SH AUTOR

.P
Aurelio Jargas <verde@aurelio.net>

.P
Manpage ins Deutsche übersetzt von Michael Malien, michael.malien@gmx.de.

.SH BUGS

.P
http://bugs.txt2tags.org

.SH COPYRIGHT

.P
Copyright (C) 2001\-2012 Aurelio Jargas, GNU GPL v2

.\" man code generated by txt2tags 2.6.641 (http://txt2tags.org)
.\" cmdline: txt2tags doc/German/manpage-de.t2t
